"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  VueHooksPlusResolver: () => VueHooksPlusResolver,
  VueHooksPlusUseImmerResolver: () => VueHooksPlusUseImmerResolver,
  VueHooksPlusUseUrlStateResolver: () => VueHooksPlusUseUrlStateResolver,
  VueHooksPlusUseWorkerResolver: () => VueHooksPlusUseWorkerResolver
});
module.exports = __toCommonJS(src_exports);

// src/unplugin-auto-import-resolver/index.ts
var import_local_pkg = require("local-pkg");
var import_node_fs = require("fs");

// src/unplugin-auto-import-resolver/useWorkerResolver.ts
var hooks;
function queryMetaData() {
  try {
    hooks = ["useWorker"];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-worker:plugins] failed to load @vue-hooks-plus/use-worker, have you installed it?"
    );
  }
}
function resolveHooks(name, options) {
  if (!hooks)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-worker"
  };
}
function VueHooksPlusUseWorkerResolver(options = {}) {
  return (name) => {
    if (!hooks) {
      queryMetaData();
    }
    return resolveHooks(name, options);
  };
}

// src/unplugin-auto-import-resolver/useImmerResolver.ts
var hooks2;
function queryMetaData2() {
  try {
    hooks2 = ["useImmer"];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-immer:plugins] failed to load @vue-hooks-plus/use-immer, have you installed it?"
    );
  }
}
function resolveHooks2(name, options) {
  if (!hooks2)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks2.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-immer"
  };
}
function VueHooksPlusUseImmerResolver(options = {}) {
  return (name) => {
    if (!hooks2) {
      queryMetaData2();
    }
    return resolveHooks2(name, options);
  };
}

// src/unplugin-auto-import-resolver/useUrlStateResolver.ts
var hooks3;
function queryMetaData3() {
  try {
    hooks3 = ["useUrlState "];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-url-state:plugins] failed to load @vue-hooks-plus/use-url-state, have you installed it?"
    );
  }
}
function resolveHooks3(name, options) {
  if (!hooks3)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks3.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-url-state"
  };
}
function VueHooksPlusUseUrlStateResolver(options = {}) {
  return (name) => {
    if (!hooks3) {
      queryMetaData3();
    }
    return resolveHooks3(name, options);
  };
}

// src/unplugin-auto-import-resolver/index.ts
var hooks4;
function queryMetaData4() {
  try {
    const root = (0, import_local_pkg.resolveModule)("vue-hooks-plus") || process.cwd();
    const path = (0, import_local_pkg.resolveModule)("vue-hooks-plus/meta-data.json") || (0, import_local_pkg.resolveModule)("vue-hooks-plus/meta-data.json", { paths: [root] });
    const metaData = JSON.parse((0, import_node_fs.readFileSync)(path, "utf-8"));
    hooks4 = metaData.function;
  } catch (e) {
    console.error(e);
    throw new Error(
      "[vue-hooks-plus:plugins] failed to load vue-hooks-plus, have you installed it?"
    );
  }
}
function resolveHooks4(name, options) {
  if (!hooks4)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks4.includes(name))
    return;
  return {
    name,
    from: "vue-hooks-plus"
  };
}
function VueHooksPlusResolver(options = {}) {
  return (name) => {
    if (!hooks4) {
      queryMetaData4();
    }
    return resolveHooks4(name, options);
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VueHooksPlusResolver,
  VueHooksPlusUseImmerResolver,
  VueHooksPlusUseUrlStateResolver,
  VueHooksPlusUseWorkerResolver
});
