// src/unplugin-auto-import-resolver/index.ts
import { resolveModule } from "local-pkg";
import { readFileSync } from "node:fs";

// src/unplugin-auto-import-resolver/useWorkerResolver.ts
var hooks;
function queryMetaData() {
  try {
    hooks = ["useWorker"];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-worker:plugins] failed to load @vue-hooks-plus/use-worker, have you installed it?"
    );
  }
}
function resolveHooks(name, options) {
  if (!hooks)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-worker"
  };
}
function VueHooksPlusUseWorkerResolver(options = {}) {
  return (name) => {
    if (!hooks) {
      queryMetaData();
    }
    return resolveHooks(name, options);
  };
}

// src/unplugin-auto-import-resolver/useImmerResolver.ts
var hooks2;
function queryMetaData2() {
  try {
    hooks2 = ["useImmer"];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-immer:plugins] failed to load @vue-hooks-plus/use-immer, have you installed it?"
    );
  }
}
function resolveHooks2(name, options) {
  if (!hooks2)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks2.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-immer"
  };
}
function VueHooksPlusUseImmerResolver(options = {}) {
  return (name) => {
    if (!hooks2) {
      queryMetaData2();
    }
    return resolveHooks2(name, options);
  };
}

// src/unplugin-auto-import-resolver/useUrlStateResolver.ts
var hooks3;
function queryMetaData3() {
  try {
    hooks3 = ["useUrlState "];
  } catch (e) {
    console.error(e);
    throw new Error(
      "[@vue-hooks-plus/use-url-state:plugins] failed to load @vue-hooks-plus/use-url-state, have you installed it?"
    );
  }
}
function resolveHooks3(name, options) {
  if (!hooks3)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks3.includes(name))
    return;
  return {
    name,
    from: "@vue-hooks-plus/use-url-state"
  };
}
function VueHooksPlusUseUrlStateResolver(options = {}) {
  return (name) => {
    if (!hooks3) {
      queryMetaData3();
    }
    return resolveHooks3(name, options);
  };
}

// src/unplugin-auto-import-resolver/index.ts
var hooks4;
function queryMetaData4() {
  try {
    const root = resolveModule("vue-hooks-plus") || process.cwd();
    const path = resolveModule("vue-hooks-plus/meta-data.json") || resolveModule("vue-hooks-plus/meta-data.json", { paths: [root] });
    const metaData = JSON.parse(readFileSync(path, "utf-8"));
    hooks4 = metaData.function;
  } catch (e) {
    console.error(e);
    throw new Error(
      "[vue-hooks-plus:plugins] failed to load vue-hooks-plus, have you installed it?"
    );
  }
}
function resolveHooks4(name, options) {
  if (!hooks4)
    return;
  const { prefix } = options;
  if (prefix) {
    if (!name.startsWith(prefix))
      return;
    name = name.substring(prefix.length);
  }
  if (!hooks4.includes(name))
    return;
  return {
    name,
    from: "vue-hooks-plus"
  };
}
function VueHooksPlusResolver(options = {}) {
  return (name) => {
    if (!hooks4) {
      queryMetaData4();
    }
    return resolveHooks4(name, options);
  };
}
export {
  VueHooksPlusResolver,
  VueHooksPlusUseImmerResolver,
  VueHooksPlusUseUrlStateResolver,
  VueHooksPlusUseWorkerResolver
};
